<h2>bch_signTransaction_V0</h2>

<p>
  <strong
    >We will probably want to replace this with BitJSON's "actions" once done,
    but this might get across the line for now.</strong
  >
</p>

<p>
  Because we want to minimize access to a Wallet's unspents, the Service should
  ONLY provide those inputs and outputs that it explicitltly needs. The other
  UTXO's will then be provided by the TransactionBuilder in the wallet. In this
  sense, Wallet is (often) responsible for both UTXO selection and Change
  Outputs. This has a few benefits:
</p>

<ol>
  <li>it's pretty good DX (simple for Service to implement)</li>
  <li>
    less chance of Service making a mistake (e.g. Service forgetting to give a
    Token Change Output).
  </li>
  <li>
    it adds security in the sense that the wallets UTXOs are not directly
    exposed (EXCEPTION below)
  </li>
</ol>

<p>
  Exception: Sometimes the Service will require a particular NFT - with a given
  commitment. When negotiating the WC Session, a list of "allowedCategoryIds"
  can be passed in. If an input is provided that does not have a `script` (i.e.
  only outpointTransactionHash and outpointIndex) AND it is in the
  allowedCategoryIds, it can be used as an input and the Wallet will sign it
</p>

<h3>Minting</h3>

<p>
  Things become a bit complex here. As we want to minimize a Service's access to
  UTXO's, we want to TRY to handle this automatically.
</p>

<p>
  If an output contains an EMPTY category, the Wallet will ATTEMPT populate that
  category with one of its available Category Genesis Outputs. But, we also want
  to be able to populate the data variables with this category id (e.g. imagine
  wanting to Lock a contract on Output 0 to a token minted on Output 1).
</p>

<p>
  A tentative approach for this is to allow the transaction builder some form of
  introspection such that this can be done as follows:
</p>

<pre>
{
  //...
  outputs: [
    {
      script: 'lock_voting_sign',
      data: {
        votingToken: "&lt;outputs.1.token.category&gt;" // Populate with Category Genesis Output #1
      },
      valueSatoshis: 100_000,
    }
    {
      script: 'mint_token',
      token: {
        category: '' // Have wallet provide a Category Genesis Output
        // ...
      },
      valueSatoshis: 100_000,
    }
  ]
}
</pre>

<p>
  This is not currently supported by LibAuth Templates but, if it's sensible, we
  might want to see if BitJSON can add something like this in his "actions"
  concept?
</p>

<p>
  We probably also want to return an array of transactions so that the wallet
  can handle generating the necessary Category Genesis Outputs (by creating the
  transactions) by pre-passing the outputs in a transaction.
</p>

<h3>Notes</h3>

<ol>
  <li>
    "script" MUST refer to a script in the template (for security, no arbitrary
    lock/unlock bytecode allowed!)
  </li>
  <li>
    data payloads must be passed as Uint8Arrays (but this tool will try to
    automatically cast them for you)
  </li>
  <li>
    if a script is not provided, it is assumed it is a Wallet Unspent that is in
    the list of allowedCategoryIds (Wallet errors if it isn't).
  </li>
  <li>
    sourceOutputs are retrieved by the wallet. This is for security (but also
    simplifies DX). We don't want the service to give in accurate picture (e.g.
    Sat Amounts) for the inputs (particularly if its a P2SH whose redeemScript
    does not verify amounts).
  </li>
</ol>

<h3>TODO</h3>

<ol>
  <li>
    Try to return resolved variables instead of redeem scripts (easier to use
    and might allow us multi-entity/multi-sig support).
  </li>
  <li>Return an array of transaction to handle "mint" use-cases</li>
  <li>
    Actually implement the "lack of script" thing I'm talking about in
    BCH-WC-Lib
  </li>
</ol>
